#include "adevs.h"
#include <cmath>
#include <iostream>
using namespace std;

int main()
{
	for (double D = 0.01; D > 0.00001; D /= 1.1)
	{
		cout << D << " "; 
		double u0 = 1.0;
		/// Solve with first order integrator
		double t = 0.0;
		double du = -1.0;
		qoden<1> q1;
		q1.setParams(D);
		q1.init(&u0,&du);
		while (t < 1.0)
		{
			t += q1.ta();
			du = -1.0*q1.out();
			q1.integ(q1.ta(),&du);
		}
		cout << fabs(exp(-1.0*t)-q1.state()) << " ";
		/// Solve with second order integrator
		t = 0.0;
		du = -1.0;
		qoden2<1> q2;
		q2.setParams(D);
		q2.init(&u0,&du);
		while (t < 1.0)
		{
			t += q2.ta();
			du = -1.0*q2.out();
			q2.integ(q2.ta(),&du);
		}
		cout << fabs(exp(-1.0*t)-q2.state()) << " ";
		/// Done
		cout << endl;
	}
	return 0;
}
