#ifndef __segment_h_
#define __segment_h_
#include <adevs.h>
#include "cell.h"

class segment: public staticDigraph 
{
	public:
		static const port_t in;
		static const port_t out;
		static const port_t stats;

		segment(int cell_count, int offset = 0):
		staticDigraph()
		{
			cell* prev = NULL;
			for (int i = 0; i < cell_count; i++)
			{
				cell* c = new cell(i+offset);
				add(c);
				if (prev == NULL) couple(this,in,c,cell::in);
				else couple(prev,cell::out,c,cell::in);
				couple(c,cell::stats,this,stats);
				prev = c;
			}
			couple(prev,cell::out,this,out);
		}
		segment(const segment& src):
		staticDigraph(src){}
		object* clone() const { return new segment(*this); }
		~segment(){}
};

#endif
